/* eslint-disable react-hooks/rules-of-hooks */
import { useGenericAuth, UnauthenticatedError } from '@envelop/generic-auth'
import { MeshPlugin } from '@graphql-mesh/types'

type UserType = {
    id: string
}

const resolveUserFn = async (context: any) => {
    const authHeader = context.req.headers.authorization;
    const authtoken = process.env.GRAPHQL_MESH
    if (authHeader !== authtoken) {
        return null
    }
    return { id: 'user1' };
}

const validateUser = (params: any) => {
    if (!params.user) {
        return new UnauthenticatedError(`Unauthenticated!`)
    }
}

const plugins: MeshPlugin<any>[] = [
    useGenericAuth({
        resolveUserFn,
        validateUser,
        mode: 'protect-all'
    })
]

export default plugins